/* Include file for circ_buf.c and  programs that use circular buffer
	routines.

	Contains structure definitions for a circular buffer.
																	*/
	typedef struct {	
		char *address;			/* begining address of buffer */
		char *end;				/* end address of circular buffer */
		int length;				/* length in bytes of circular buffer */
		char *head;				/* head pointer of newest or first byte is */
		char *tail;				/* tail pointer of oldest or last byte is */
		int char_count;		/* number of characters in buffer */
		char overflow_flag;	/* overflow flag, set if too many characters..*/
									/* ...have tried to be put in buffer..*/
									/* ...(set by interrupt "in" routines if buffer ..*/
									/* ... is used for interrupt "in" routines) */
		}circ_buffer_description;


