
          BatMenu (Version 4.00.00)

          Basic Syntax
          ------------

          BatMenu column line title item item... [/switch[/switch[...]]]
          or
          BatMenu @filename.ext [/switch[/switch[...]]]

          Switches
          --------
          /+n                 start with menu bar at item n

          /Beep               emit a brief high-frequency tone on entry

          /GetScr             restore screen from a file
                              If directive #SaveScr= is not set, get screen
                              from BMSCREEN.DAT on the currentky logged
                              drive.

          /Keep               don't restore the screen on exit

          /LastItem           start with menu bar at last menu item

          /Message            don't display a menu bar

          /NoBar              use a block cursor instead of a menu bar

          /NoRedraw           don't repaint selection box on entry

          /NoWait             don't wait for user input, display and exit

          /SaveScr            save screen to a file BEFORE drawing the menu.
                              If directive #SaveScr= is not set, save screen
                              to BMSCREEN.DAT on the currentky logged drive.


          Menu File Syntax
          ----------------
          # comment  - Comments may appear at the beginning of the menu file          
          #directive - No space between the # and the directive.
          x
          y
          title  (use semicolon for no title, environment variables are valid)
          item   (environment variables are valid)
          item
          .
          .
          .


          Hot Keys
          --------
          If a ~ (tilde) appears in a menu item, the character following it
          is taken  to be a hot  key. These must  be unique as there  is no
          error checking with  this feature. For example E~xit would appear
          on the menu  as  Exit on the  screen and `x' would  activate that
          item. This feature is not case sensitive.



          Forcing Errorlevel
          ------------------

          You may force the errorlevel returned to be something other
          than the position of the item in the menu by preceeding
          the menu item with !n: where 1 < n < 128
          eg:

          !100:E~xit

          would cause a return of 100 if selected, regardless of
          the item's position in the menu.


         Specifying StatusBar Text
         -------------------------

         If the #StatusBar directive appears in the menu file (see below)
         you may optionally specify a text string of up to 39 characters
         which will appear on the right side of the status line. The `|'
         is used to seperate the beginning of the item from StatusBar text,
         so if you wish to use the `|' as a part of the item text, preceed
         it with the literal flag [`] (backquote).
         eg:

         !100:E~xit`|Quit`|Run Away|Leave this menu now!

         would display

           Exit|Quit|Run Away

         as the menu item and

           Leave this menu now!

         would appear on the status bar when this item is highlighted by
         the menu selection bar.



        Specifying Help Files/Arguments
        -------------------------------

        By default, requesting help from within BatMenu will result in
        the presentation of a brief description of menu operation commands.
        If an external help utility is specified with the #Help=filespec
        directive or the name of a help text file is present on the
        item line, The help panel will display the option `F1 more'.
        If the `Imediate line help' flag is present on the item line,
        the default help screen will be bypassed and the specified help
        will be activated.
        The flag for `This is the argument for the external help facility'
        is the `<' left angle bracket (or FROM symbol). The `this is
        the name of the help file for BatMenu's internal help' flag is
        `>', the right angle bracket or `TO' symbol. The `Imediate line
        help' flag is `!' the exclamation point or `BANG'. This is used
        in conjunction with help locator ( `>' or `<' ).

        eg:

          !5:Wordprocessing|C:\`> Menu WP>!%MenuArea%\HLP\WP.BMH

        would display `Wordprocessing' in the item area,
        `C:\> Menu WP' in the StatusBar area, (note literal flag
        before the > ) return an errorlevel of 5 if selected, and
        would display the helpfile %MenuArea%\HLP\WP.BMH if F1 was
        pressed while this item was highlighted. Since the > is followed
        by a ! the opening default help screen would be bypassed.

          TeX<TEX

       would display TeX as the item and pass the argument TEX to
       the help facility specified by the directive #Help=filespec.


       Menufile Directives
       -------------------
       #AltX=n             Errorlevel to return when Alt-X is entered.
                           (where 0 < n < 255 and default = 0)

       #backdrop "text"    display backdrop.  (Title delimiter is user
                           defined, first character after space)

       #clock              display time (and  date if room permits) at
                           bottom of menu box.

       #ExitY n            position DOS cursor at line n on exit
 
       #Help=fileSpec      complete filespec for external help executable
                           to be invoked when F1 or the right mouse
                           button is pressed. Argument to be passed to
                           this facility is specified on the menu item
                           line. Environment variables are permitted
                           here.

       #SaveScr=filespec    complete filespec for screen buffer file.
                            (see switches /GetScr, /SaveScr)

       #StatusBar           display status bar on bottom line. Text will
                            appear in the text area of the text area of
                            the status bar if specified on the item line.
                            Environment variables are permitted here.

       #window n           display a maximum of n items in the window


       Environment Variables
       ---------------------

       DOS  environment variables are valid only in the title and fields
       of the menu file. The environment variable must  be enclosed in %
       delimiters thus: %env-var%
       If you wish  to display the % itself, it must be preceeded by a `
       (back-quote)  which is the default  literal flag used by BatMenu.
       The  specification  of  the  environment  variable  is  not  case
       sensitive.

       Limitations:

       The name  of the  environment variable  may not  exceed twelve
       characters.

       The contents ofthe environment variable may not exceed 39
       characters.
