/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  (C) Copyright 1987-91, Bit Bucket Software Co., a Delaware Corporation. */
/*                                                                          */
/*                                                                          */
/*           Keyboard Scan Code definitions used in BinkleyTerm             */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.250.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:491/0                          */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#ifndef MILQ_REMAP_KB
#define ALT_SHIFT       0
#define CTL_SHIFT       0
#define SHIFT_SHIFT     0

#define ALTA  0x1e00
#define ALTB  0x3000
#define ALTC  0x2e00
#define ALTD  0x2000
#define ALTE  0x1200
#define ALTF  0x2100
#define ALTG  0x2200
#define ALTH  0x2300
#define ALTI  0x1700
#define ALTJ  0x2400
#define ALTK  0x2500
#define ALTL  0x2600
#define ALTM  0x3200
#define ALTN  0x3100
#define ALTO  0x1800
#define ALTP  0x1900
#define ALTQ  0x1000
#define ALTR  0x1300
#define ALTS  0x1f00
#define ALTT  0x1400
#define ALTU  0x1600
#define ALTV  0x2f00
#define ALTW  0x1100
#define ALTX  0x2d00
#define ALTY  0x1500
#define ALTZ  0x2c00

#define CTRLC  0x2e03

#define ALT1  0x7800
#define ALT2  0x7900
#define ALT3  0x7a00
#define ALT4  0x7b00
#define ALT5  0x7c00
#define ALT6  0x7d00
#define ALT7  0x7e00
#define ALT8  0x7f00
#define ALT9  0x8000
#define ALT0  0x8100
#define ALTEQ 0x8300

#define PGUP  0x4900
#define PGDN  0x5100

#define ALTF1 0x6800
#define ALTF2 0x6900
#define ALTF3 0x6a00
#define ALTF4 0x6b00
#define ALTF5 0x6c00
#define ALTF6 0x6d00
#define ALTF7 0x6e00
#define ALTF8  0x6f00
#define ALTF9 0x7000
#define ALTF10  0x7100

#define PF1 0x3b00
#define PF2 0x3c00
#define PF3 0x3d00
#define PF4 0x3e00
#define PF5 0x3f00
#define PF6 0x4000
#define PF7 0x4100
#define PF8 0x4200
#define PF9 0x4300
#define PF10  0x4400

#define UPAR  0x4800
#define LFAR  0x4b00
#define RTAR  0x4d00
#define DNAR  0x5000
#define HOME   0x4700
#define END    0x4f00

#define SHF1  0x5400
#define SHF2  0x5500
#define SHF3  0x5600
#define SHF4  0x5700
#define SHF5  0x5800
#define SHF6  0x5900
#define SHF7  0x5a00
#define SHF8  0x5b00
#define SHF9  0x5c00
#define SHF10 0x5d00
#endif

#ifdef MILQ_REMAP_KB
#define ALT             ALT_SHIFT
#define CTL             CTL_SHIFT
#define SHIFT           SHIFT_SHIFT

#define ALTA            VK_ALT_A
#define ALTB            VK_ALT_B
#define ALTC            VK_ALT_C
#define ALTD            VK_ALT_D
#define ALTE            VK_ALT_E
#define ALTF            VK_ALT_F
#define ALTG            VK_ALT_G
#define ALTH            VK_ALT_H
#define ALTI            VK_ALT_I
#define ALTJ            VK_ALT_J
#define ALTK            VK_ALT_K
#define ALTL            VK_ALT_L
#define ALTM            VK_ALT_M
#define ALTN            VK_ALT_N
#define ALTO            VK_ALT_O
#define ALTP            VK_ALT_P
#define ALTQ            VK_ALT_Q
#define ALTR            VK_ALT_R
#define ALTS            VK_ALT_S
#define ALTT            VK_ALT_T
#define ALTU            VK_ALT_U
#define ALTV            VK_ALT_V
#define ALTW            VK_ALT_W
#define ALTX            VK_ALT_X
#define ALTY            VK_ALT_Y
#define ALTZ            VK_ALT_Z

#define CTRLC           VK_CTRL_C

#define ALT1            VK_ALT_1
#define ALT2            VK_ALT_2
#define ALT3            VK_ALT_3
#define ALT4            VK_ALT_4
#define ALT5            VK_ALT_5
#define ALT6            VK_ALT_6
#define ALT7            VK_ALT_7
#define ALT8            VK_ALT_8
#define ALT9            VK_ALT_9
#define ALT0            VK_ALT_0

#define PGUP            VK_PGUP
#define PGDN            VK_PGDN

#define ALTF1           VK_ALT_F1
#define ALTF2           VK_ALT_F2
#define ALTF3           VK_ALT_F3
#define ALTF4           VK_ALT_F4
#define ALTF5           VK_ALT_F5
#define ALTF6           VK_ALT_F6
#define ALTF7           VK_ALT_F7
#define ALTF8           VK_ALT_F8
#define ALTF9           VK_ALT_F9
#define ALTF10          VK_ALT_F10

#define PF1             VK_F1
#define PF2             VK_F2
#define PF3             VK_F3
#define PF4             VK_F4
#define PF5             VK_F5
#define PF6             VK_F6
#define PF7             VK_F7
#define PF8             VK_F8
#define PF9             VK_F9
#define PF10            VK_F10

#define UPAR            VK_UP
#define LFAR            VK_LEFT
#define RTAR            VK_RIGHT
#define DNAR            VK_DOWN
#define HOME            VK_HOME
#define END             VK_END

#define SHF1            VK_SH_F1
#define SHF2            VK_SH_F2
#define SHF3            VK_SH_F3
#define SHF4            VK_SH_F4
#define SHF5            VK_SH_F5
#define SHF6            VK_SH_F6
#define SHF7            VK_SH_F7
#define SHF8            VK_SH_F8
#define SHF9            VK_SH_F9
#define SHF10           VK_SH_F10
#endif

