--***************************************************************--
--                                                               --
--  TITLE:          AN ADA SOFTWARE METRIC                       --
--                                                               --   
--  MODULE NAME:    PACKAGE SPECIFICATION PARSER_4               --
--  FILE NAME:      PARSER_4.ADS                                 --
--                                                               --
--  LAST MODIFIED:  02 MAR 90                                    --
--                                                               --
--  DESCRIPTION:  This package contains seven functions that     --
--       are the lowest level productions for our top-down,      --
--       recursive descent parser.  Each function is preceded    --
--       by the grammar productions they are implementing.       --
--                                                               --  
--  COPYRIGHT:  The Ada source code in this file is Copyright    --
--              1990 by Source Translation & Optimization. There --
--              are no restrictions to the use of this source    --
--              code in any product or system that is released   --
--              in non-source code form. Resale of this source   --
--              code, without permission of STO, is a violation  --
--              of our Copyright.                                --
--                                                               --
--                                                               --
--  HELP:       For more information contact: Gregory Aharonian  --
--              Source Translation & Optimization, P.O. Box 404  --
--              Belmont, MA, 02178-0404            617-489-3727  --
--***************************************************************--

package PARSER_4 is
    function  MULTIPLYING_OPERATOR         return boolean;
    function  BINARY_ADDING_OPERATOR       return boolean;
    function  RELATIONAL_OPERATOR          return boolean;
    function  ENUMERATION_TYPE_DEFINITION  return boolean;
    function  FORMAL_PARAMETER             return boolean;
    function  SELECTOR                     return boolean;

--
-- The following procedures are declared locally in the package body
--
--    function ENUMERATION_LITERAL return boolean;


end PARSER_4;
