--***************************************************************--
--                                                               --
--  TITLE:          AN ADA SOFTWARE METRIC                       --
--                                                               --   
--  MODULE NAME:    PACKAGE SPECIFICATION PARSE_2A               --
--  FILE NAME:      PARSE_2A.ADS                                 --
--                                                               --
--  LAST MODIFIED:  24 APR 89                                    --
--                                                               --
--  DESCRIPTION:  This package contains thirty-three functions   --
--       that are the middle level productions for our top-down, --
--       recursive descent parser.  Each function is preceded    --
--       by the grammar productions they are implementing.       --
--                                                               --  
--  CHANGE LOG:                                                  --
--              - added the check for a semicolon in function    --
--                RECORD_REPRESENTATION_CLAUSE (bug fix).        --
--                                                               --  
--  COPYRIGHT:  The Ada source code in this file is Copyright    --
--              1990 by Source Translation & Optimization. There --
--              are no restrictions to the use of this source    --
--              code in any product or system that is released   --
--              in non-source code form. Resale of this source   --
--              code, without permission of STO, is a violation  --
--              of our Copyright.                                --
--                                                               --
--                                                               --
--  HELP:       For more information contact: Gregory Aharonian  --
--              Source Translation & Optimization, P.O. Box 404  --
--              Belmont, MA, 02178-0404            617-489-3727  --
--***************************************************************--

package PARSER_2 is

  function GENERIC_ACTUAL_PART        return boolean;
  function GENERIC_TYPE_DEFINITION    return boolean;
  function PRIVATE_TYPE_DECLARATION   return boolean;
  function TYPE_DECLARATION           return boolean;
  function SUBTYPE_DECLARATION        return boolean;
  function DISCRIMINANT_PART          return boolean;
  function WITH_OR_USE_CLAUSE         return boolean;
  function FORMAL_PART                return boolean;
  function IDENTIFIER_DECLARATION     return boolean;
  function EXCEPTION_CHOICE           return boolean;
  function IDENTIFIER_LIST            return boolean;
  function MODE                       return boolean;
  function DESIGNATOR                 return boolean;
  function SIMPLE_STATEMENT           return boolean;
  function LABEL                      return boolean;
  function ENTRY_DECLARATION          return boolean;
  function REPRESENTATION_CLAUSE      return boolean;

--
-- The following procedures are declared locally in the package body
--
--    function DISCRIMINANT_SPECIFICATION     return boolean;
--    function PARAMETER_SPECIFICATION        return boolean;


end PARSER_2;
