/*
	SNEWS 1.91

	PCCHARST.H - public decls in pccharst.c

    Copyright (C) 1993  Daniel Fandrich
						<dan@fch.wimsey.bc.ca> or CompuServe 72365,306


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 1, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    See the file COPYING, which contains a copy of the GNU General
    Public License.


	Source is formatted with a tab size of 4.

 */

#define DEFAULT_CHAR_SET X_IBM437	/* change this to read from .rc file */

/* Make sure code_page_list[] contains all these */
enum code_pages {CP437=0, CP850, /* CP852, CP857, CP860, CP861, CP863, CP865, */ CP_NOT_SUPP};

/* Make sure char_set_names[] matches these enums */
/* US_ASCII must be last */
enum char_sets {X_IBM437=0, ISO_8859_1, ISO_8859_2, ISO_8859_3,
								ISO_8859_4, ISO_8859_9, US_ASCII};

extern enum code_pages code_page_table;

int get_code_page(void);
enum code_pages select_cp_table(int code_page_num);
enum char_sets select_char_set(char *name);
unsigned char translate_char(unsigned char inchar, enum char_sets cset);
char *translate_line(char *origline, enum char_sets cset);
char *translate_header(char *origline, enum char_sets cset);
