/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  (C) Copyright 1987-91, Bit Bucket Software Co., a Delaware Corporation. */
/*                                                                          */
/*                                                                          */
/*               Prototype definitions used in BinkleyTerm                  */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.250.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:491/0                          */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#ifdef NEED_DOSREAD
int             _dos_read(int, void far *, unsigned, unsigned int *);
int             _dos_write(int, void far *, unsigned, unsigned int *);
#endif

#ifdef NEED_CPUTS
int _cdecl cputs (const char *);
#endif

#ifdef NEED_PUTCH
int _cdecl putch (int);
#endif

#ifdef NEED_CPRINTF
int _cdecl cprintf (const char *, ...);
#endif

#ifdef NEED_MKTEMP
extern char *mktemp (char *);
#endif


#ifndef OS_2
int             MODEM_IN (void);
int             MODEM_STATUS (void);
int             PEEKBYTE (void);
void            SENDBYTE (unsigned char);
void            CLEAR_INBOUND (void);
void            CLEAR_OUTBOUND (void);
void            SENDCHARS (char far *, unsigned int, int);
void            do_break (int);
int _cdecl      real_flush (int);
#else
void            WRITE_ANSI (char);
int             dir_findfirst (char far *, int, struct FILEINFO *);
int             dir_findfirsta (char far *, int, struct FILEINFO *);
int             dir_findnext (struct FILEINFO *);
int             dir_findnexta (struct FILEINFO *);
void            set_fileinfo (int, unsigned, unsigned);
#endif /* OS_2  */

#ifdef Snoop
static int far pascal _loadds mesgfunc(int error, char far *mesq);
void            snoop_open(char *pipename);
void            snoop_close(void);
#endif /* Snoop */

#ifdef MILQ
#include "MilqProt.H"
#endif

struct _key_fnc_hdr    *KbMapSet( struct _key_fnc_hdr *KeyFncHdr );

#ifndef MILQ
unsigned pascal         KbRemap( unsigned ScanCode );
#endif

void            com_kick (void);
void            b_sbinit (void);

#ifndef MILQ
void            sb_box (REGIONP, int, int);
void            sb_caption(REGIONP, char * );
#endif

void            sb_clean (void);
void            sb_dirty (void);

#ifndef MILQ
void            sb_fill (REGIONP, int, int);
void            sb_filla (REGIONP, int);
void            sb_fillc (REGIONP, int);
#endif

void            sb_init (void);

#ifndef MILQ
void            sb_move (REGIONP, int, int);
#endif

int             sb_input_chars (REGIONP, int, int, char *, int);
REGIONP         sb_new (int, int, int, int);
int             sb_popup (int, int, int, int, int (*) (BINK_SAVEP, int), int);
int             sb_putc (REGIONP, int);

#ifndef MILQ
void            sb_puts (REGIONP, char *);
#endif

#ifndef MILQ
unsigned char   sb_ra (REGIONP, int, int);
unsigned char   sb_rc (REGIONP, int, int);
unsigned int    sb_rca (REGIONP, int, int);
#endif

void            sb_restore (BINK_SAVEP);
BINK_SAVEP      sb_save (int, int, int, int);

#ifndef MILQ
void            sb_scrl (REGIONP, int);
int             sb_set_scrl (REGIONP, int, int, int, int);
#endif

void            sb_show (void);

#ifndef MILQ
void            sb_wa (REGIONP, int, int);
void            sb_wc (REGIONP, int, int);
void            sb_wca (REGIONP, int, int, int);
#endif

int             Overlay_Do_Get (BINK_SAVEP, int);
int             Do_Get (BINK_SAVEP, int);
int             Overlay_Do_Get (BINK_SAVEP, int);
int             Do_Send (BINK_SAVEP, int);
int             Overlay_Do_Send (BINK_SAVEP, int);
int             Do_Kill (BINK_SAVEP, int);
int             Overlay_Do_Kill (BINK_SAVEP, int);
int             Do_Poll (BINK_SAVEP, int);
int             Overlay_Do_Poll (BINK_SAVEP, int);

int             Upload (char *, int, char *);
int             Download (char *, int, char *);

void            set_prior (int);
int             load_language (void);
void            b_initvars (void);
void            b_defaultvars (void);
void            b_exitproc (void);
int             got_ESC (void);
void            BBSexit (void);
char           *estring (int, int);
long            timerset (unsigned int);
int             timeup (long);
void            dostime (int *, int *, int *, int *);
void _cdecl     time_release (void);
unsigned        Cominit (int, int);
unsigned        Com_ (char, byte);
void            MDM_DISABLE (void);
void            MDM_ENABLE (unsigned);
void            BUFFER_BYTE (unsigned char);
void            UNBUFFER_BYTES (void);
void            fossil_gotoxy (int, int);
int             fossil_wherex (void);
int             fossil_wherey (void);
unsigned _cdecl windows_active (void);
unsigned _cdecl dv_get_version (void);
unsigned _cdecl tv_get_version (void);
unsigned _cdecl ddos_active (void);
unsigned _cdecl ml_active (void);
unsigned _cdecl mos_active (void);
void            dos_break_off (void);
void            mtask_find (void);
void _cdecl     windows_pause (void);
void _cdecl     mos_pause (void);
void _cdecl     dv_pause (void);
void _cdecl     ddos_pause (void);
void _cdecl     tv_pause (void);
void _cdecl     ml_pause (void);
void _cdecl     msdos_pause (void);
void _cdecl     os2_pause (void);
void            status_line (char *,...);
int             time_to_next (int);
void            write_sched (void);
void            close_up (void);
void            scr_printf (char *);
int             SendBanner (char far *);
void            opening_banner (void);
void            mailer_banner (void);
void            UUCPexit (int);
void            come_back (void);
char            *fancy_str (char *);
int             got_error (char *, char *);
int             dfind (struct FILEINFO *, char *, int);
int             n_frproc (char *, int, int (*)(char *), int (*)(long));
void            Make_Response (char *, int);
int             do_FLOfile (char *, int (*)(char *));
void            ovl_fidouser (char *, ADDR *);
void            fidouser (char *, ADDR *);
void            opususer (char *, ADDR *);
void            main_help (void);
void            mailer_help (void);
int             n_password (char *, char *);
int             n_getpassword (ADDR *);
int             nodefind (ADDR *, int);
void            do_extern (char *, int, char *);
int             dexists (char *);
int             do_script (char *);
void            timer (int);
void            mdm_cmd_string (char *, int);
void            send_break (int);
void            mdm_cmd_char (int);
int             modem_response (int);
int             set_baud (unsigned, int);
void            program_baud (void);
int             list_search (void);
int             checklist (void);
int             nodeproc (char *);
int             try_1_connect (char *);
void            gong (void);
void            b_init (void);
void            b_session (int);
void            do_ready (char *);
int             com_getc (int);
int             FTSC_receiver (int);
int             Whack_CR (void);
void            FTSC_sender (int);
int             YooHoo_Receiver (void);
void            last_type (int, ADDR *);
void            WaZOO (int);
int             YooHoo_Sender (void);
int             get_Zmodem (char *, FILE *);
int             Send_Zmodem (char *, char *, int, int);
int             send_WaZOO (void);
int             respond_to_file_requests (int, int (*)(char *), int (*)(long) );
void            mdm_hangup (void);
void            Janus (void);
void            invent_pkt_name (char *);
int             send_Hello (int);
void            set_xy (char *);
char            *receive_file (char *, char *, char);
void            read_sched (void);
void            parse_config (char *);
char *          ctl_string (char *);
int             parse (char *, struct parse_list far *);
void            bottom_line (void);
void            do_today (void);
void            boss_mail (int);
int             unattended (void);
int             get_number (char *);
char           *numdisp (long);
void            try_2_connect (char *);
void            change_prompt (void);
int             do_mail (ADDR *, int);
void            ansi_map (unsigned int);
void            mdm_init (char *);
void            fossil_ver (void);
char            *zalloc (void);
int             xfermdm7 (char *);
int             send_file (char *, char);
int             recvmdm7 (char *);
void            main (int, char **);
int             opusfind (ADDR *, int);
int             ver7find (ADDR *, int);
#ifdef QUICK_LIST
int             QuickLookup (ADDR *, int);
#endif
int             TBBSLookup (ADDR *, int);
char            *skip_blanks (char *);
int             parse_event (char *);
char            *skip_to_blank (char *);
void            SEA_sendreq (void);
int             try_sealink (void);
int             SEA_recvreq (void);
void            clear_filetransfer (void);
void            throughput (int, unsigned long);
int             is_arcmail (char *, int);
void            update_files (int);
void            send_can (void);
int             bad_call (ADDR *, int);
void            receive_exit (void);
void            xmit_sameplace (void);
void            clear_statusline (void);
void            find_event (void);
void            errl_exit (int);
long            random_time (int);
int             handle_inbound_mail (int);
void            xmit_reset (void);
int             xmit_next (ADDR *);
void            put_up_time (void);
void            adios (int);
void            big_pause (int);
long            zfree (char *);
void            show_debug_name (char *);
char            *check_netfile (char *);
void            unique_name (char *);
void            write_sched (void);
void            z_message (char *);
int             Z_GetByte (int);
void            Z_PutString (unsigned char *);
void            Z_SendHexHeader (unsigned int, unsigned char *);
int             Z_GetHeader (unsigned char *);
int             Z_GetZDL (void);
void            Z_PutLongIntoHeader (long);
void            z_log (char *);
void            show_loc (unsigned long, unsigned int);
void            Z_UncorkTransmitter (void);
void            z_log (char *);
char            *add_backslash (char *);
char            *delete_backslash (char *);
void            vfossil_init (void);
void            vfossil_close (void);
void            vfossil_cursor (int);
MAILP           find_mail (ADDR *);
void            xmit_window (MAILP);
void            xmit_delete (void);
char            *HoldAreaNameMunge(ADDR *);
int             LoadScanList (int, int);
void            swapper (char far *, char far *, int, char far *, unsigned);
void            b_spawn (char *);
void            do_dial_strings (void);
void            exit_DTR (void);
void            delete_old_file (char *);
long            cost_of_call (long, long);
void            screen_clear (void);
void            clear_eol (void);
void            log_product (int, int, int);
int             b_term (void);
void            set_up_outbound (void);
int             is_user (char *);
int             next_minute (void);
void            can_Janus (char *);
int             Modem7_Receive_File (char *);
int             Modem7_Send_File (char *);
int             Batch_Receive (char *);
int             Batch_Send (char *);
int             Xmodem_Send_File (char *, char *);
int             Xmodem_Receive_File (char *, char *);
int             SEAlink_Send_File (char *, char *);
int             Telink_Send_File (char *, char *);
unsigned int    crc_block(unsigned char *, int);
void            Data_Check (XMDATAP, int);
void            Get_Block (XMARGSP);
int             Xmodem_Send (int, int, long);
void            Send_Block (XMARGSP);
int             calc_window (void);
int             Receive_Resync (long *);
void            Xmodem_Error (char *, long);
int             Header_in_data (unsigned char *);
void            Find_Char (int);
int             Xmodem_Receive (int, char *);
void            Send_Response (int, int *, int *, int *, long, int, long);
void            Set_Up_Telink (XMDATAP, TLDATAP, long *);
void            End_Telink (int, TLDATAP, XMDATAP, char *, int);
void            Wait_Clear (int);
void            Send_Resync (long, int);
int             state_machine (STATEP, void *, int);
int             Bark_Request (char *, char *, char *, char *);
void            Build_Bark_Packet (BARKARGSP);
int             Receive_Bark_Packet (BARKARGSP);
int             Batch_Xmodem_Receive_File (char *, char *);
long            Set_Up_Restart (XMARGSP);
void            Finish_Xmodem_Receive (XMARGSP);
void            Get_Telink_Info (XMARGSP);
int             Read_Block (XMARGSP);
void            Check_ACKNAK (XMARGSP);
void            show_block (long, char *, XMARGSP);
int             check_failed (char *, char *, char *, char *);
void            add_abort (char *, char *, char *, char *, char *);
void            remove_abort (char *, char *);
void            Build_Header_Block (XMARGSP, char);
void            show_sending_blocks (XMARGSP);
char           *show_num (XMARGSP, long);
void            elapse_time (void);
int             parse_address (char *, ADDR *);
int             find_address (char *, ADDR *);
char            *Hex_Addr_Str (ADDR *);
char            *Full_Addr_Str (ADDR *);
char            *add_domain (char *);
char            *find_domain (char *);
int             flag_file (int, ADDR *, int);
void            MNP_Filter (void);
int             term_overlay (int);
void            write_stats (void);
void            list_next_event (void);
int             machine (STATEP, void *, int);
int             share_open (char *, int, int);
FILE            *share_fopen (char *, char *, int);
#ifdef MILQ
char           *ZMdmFlNmCndtn( char *Dst, char *Src, char *TblNm, int Mode );
#endif

