MS-DOS patches to perl.
Apply this patch to the standard perl source, version 4, patch level 19,
using "patch -p."  Do this in the root directory of the perl source
distribution.

You can cat all these patches together and pipe the output to patch -p.

Len Reed
Holos Software, Inc.
..!gatech!holos0!lbr
holos0!lbr@gatech.edu
--------------------------------------
*** msdos/Makefile.old	Sat Apr 20 20:49:20 1991
--- msdos/Makefile	Sun Jan  5 21:04:58 1992
***************
*** 1,101 ****
! #
! # Makefile for compiling Perl under MS-DOS
! #
! # Needs a Unix compatible make.
! # This makefile works for an initial compilation.  It does not
! # include all dependencies and thus is unsuitable for serious
! # development work.  But who would do serious development under
! # MS-DOS?
! #
! # By Diomidis Spinellis, March 1990
! #
  
  # Source files
- SRC = array.c cmd.c cons.c consarg.c doarg.c doio.c dolist.c dump.c \
- eval.c form.c hash.c perl.y perly.c regcomp.c regexec.c \
- stab.c str.c toke.c util.c msdos.c popen.c directory.c
  
! # Object files
! OBJ = perl.obj array.obj cmd.obj cons.obj consarg.obj doarg.obj doio.obj \
! dolist.obj dump.obj eval.obj form.obj hash.obj perly.obj regcomp.obj \
! regexec.obj stab.obj str.obj toke.obj util.obj msdos.obj popen.obj \
! directory.obj
  
! # Files in the MS-DOS distribution
! DOSFILES=config.h dir.h director.c glob.c makefile msdos.c popen.c readme.msd \
! changes.dds wishlist.dds patches manifest
  
! # Yacc flags
! YFLAGS=-d
  
! # Manual pages
! MAN=perlman.1 perlman.2 perlman.3 perlman.4
  
! CC=cc
! # Cflags for the files that break under the optimiser
! CPLAIN=-AL -DCRIPPLED_CC
! # Cflags for all the rest
! CFLAGS=$(CPLAIN) -Ox
! # Destination directory for executables
! DESTDIR=\usr\bin
  
! # Deliverables
! all: perl.exe perl.1 glob.exe
  
! perl.exe: $(OBJ)
! 	echo array+cmd+cons+consarg+doarg+doio+dolist+dump+ >perl.arp
! 	echo eval+form+hash+perl+perly+regcomp+regexec+ >>perl.arp
! 	echo stab+str+toke+util+msdos+popen+directory+\lib\setargv >>perl.arp
! 	echo perl.exe >>perl.arp
! 	echo nul >>perl.arp
! 	echo /stack:32767 /NOE >>perl.arp
! 	link @perl.arp
  
! glob.exe: glob.c
! 	$(CC) glob.c \lib\setargv.obj -link /NOE
  
! array.obj: array.c
! cmd.obj: cmd.c
! cons.obj: cons.c perly.h
! consarg.obj: consarg.c
! 	$(CC) $(CPLAIN) -c consarg.c
! doarg.obj: doarg.c
! doio.obj: doio.c
! dolist.obj: dolist.c
! dump.obj: dump.c
! eval.obj: eval.c evalargs.xc
! form.obj: form.c
! hash.obj: hash.c
! perl.obj: perl.y
! perly.obj: perly.c
! regcomp.obj: regcomp.c
! regexec.obj: regexec.c
! stab.obj: stab.c
! str.obj: str.c
! toke.obj: toke.c
! util.obj: util.c
! 	$(CC) $(CPLAIN) -c util.c
! perly.h: perl.obj
! 	mv ytab.h perly.h
! directory.obj: directory.c
! popen.obj: popen.c
! msdos.obj: msdos.c
  
! perl.1: $(MAN)
! 	nroff -man $(MAN) >perl.1
  
! install: all
! 	exepack perl.exe $(DESTDIR)\perl.exe
! 	exepack glob.exe $(DESTDIR)\glob.exe
  
! clean:
! 	rm -f *.obj *.exe perl.1 perly.h perl.arp
  
! tags:
! 	ctags *.c *.h *.xc
  
! dosperl:
! 	mv $(DOSFILES) ../perl30.new
  
! doskit:
! 	mv $(DOSFILES) ../msdos
--- 1,251 ----
! # Dmake makefile for compiling Perl under MS-DOS
  
+ # Dmake runs on MS-DOS, OS/2, and Unix, and is available
+ # for anonymous ftp from watmsg.uwaterloo.ca.  Address is 129.97.129.9.
+ # It is in the pub/src directory, set your mode to binary, and copy
+ # either:
+ #    dmake-3.7.tar.Z		- compressed tar format
+ #    dmake-3.7.zoo		- zoo archive
+ 
+ .SWAP :		# swap dmake when running subprocesses
+ 
+ # Major options:
+ #  $(MKS_SUPPORT) is defined as Yes if MKS support is compiled in; it is
+ #	undefined (i.e., $(NULL)), if MKS support is compiled out.  Note
+ #	MKS support can still be disabled by the environment or by the perl
+ #	script, so do not undefine this for executables that will
+ #	receive wide distribution.
+ # $(MSC_VER) is the version of Microsoft C.  It should be 500, 510
+ #	or 600 for 5.0, 5.1, or 6.0 respectively.
+ # $(DEBUGGING) is set to get codeview switches.  Not of much use for 5.x
+ #	since there's not enough space for CV and perl.
+ # $(MIN_DOS_VER) is the minimum DOS version supported.  Defaults to 2.00.
+ #	Can be set higher for some efficiencies at the cost of compatiblity.
+ # $(PROCESSOR) can be set to get the compiler to generate instructions other
+ #	that 8086.  It should be set to 0 (8086, the default), 1 (80186),
+ #	or 2 (80286).
+ # $(FPOINT) can be set to specify floating point support.  If unspecified
+ #	the compiler default is used.  -FPa does not work with MSC 5.x:
+ #	unresolved exernals in consarg.obj result even without -Oi,
+ #	hence it is overridden to -FPc.
+ #	-FPa produces the smallest code for MSC 6.0, but will not use
+ #	the math coprocessor.
+ # $(WHERE_ARGV) is where to find Microsoft's argv.obj globber, used by
+ #	perlglob.exe.  Defaults to $LIB environment variable, but see
+ #	warnings where this is .IMPORTed.
+ # $(GDBM) is defined Yes if the MS-DOS gdbm support is to be included.
+ # $(GDBM_LNAME) is the gdbm library name.  Defaults to LGDBM.LIB.
+ #   Ignored if $(GDBM) not defined
+ 
+  MKS_SUPPORT	:= Yes		# note can still override at perl runtime
+  MSC_VER	:= 600
+  #DEBUGGING	:= 1
+  MIN_DOS_VER	:= 3.30
+  PROCESSOR	:= 2		# 2 for 80286
+  FPOINT		:= -FPa
+  WHERE_ARGV	:= d:/mc/lib
+  GDBM		:= Yes
+ 
+ # Attempt to handle building with MKS Korn shell or command.com.
+ # Not tested without MKS toolkit, so it probably won't work without changes.
+ 
+ .IF $(SHELL) == $(COMSPEC)
+   CP		  = $(COMSPEC) $(SWITCHAR)c copy
+   MKDIR		  = mkdir
+   SOURCE	  = $(<:s,/,\)
+   TARGET	  = $(@:s,/,\)
+ .ELSE
+   MKDIR		 := %mkdir
+   CP		 := cp -m
+   SOURCE	  = $<
+   TARGET	  = $@
+ .END
+ 
+ # Override any setting of CL (compiler flags) in the environment.
+ 
+  CL :=
+ .EXPORT : CL
+ 
+ .IF $(PROCESSOR) == $(NULL)
+   PROCESSOR := 0	# default is 8086/8088
+ .END
+ 
+ # Where to look for things. 
+ 
+ .SOURCE.h  :	. ..
+ .SOURCE.c  :	.. ../os2	# current directory searched first
+ .SOURCE.xc : 	..
+ 
+ # Header files
+ 
+ HFILES := arg array cmd config extern form handy hash intern \
+ 	  patchlev perl perly regcomp regexp spat stab str util
+ 
  # Source files
  
! AFILES   := exec	# this must be first for swapping to work
! AFILES  +:= moredos
  
! CFILES   := array chdir cmd cons consarg director doarg doio dolist	\
! 	    dump eval form hash msdos perl perly popen regcomp regexec	\
! 	    stab str subproc suffix swpspawn toke usersub util
  
! # The WHERE_ARGV directory is needed to make perlglob$E.
! # This is where to find setargv.obj, usually the LIB sudirectory of the
! # compiler stuff.  If not set above, use environment variable LIB.
! # If this is done, LIB can only have one directory, even though many
! # programs (including LINK) allow semicolon-separated dirrectories a la PATH.
! # If your system has multiple directories, set WHERE_ARGV above.
  
! .IF $(WHERE_ARGV) == $(NULL)
!   .IMPORT    : LIB
!   WHERE_ARGV := $(LIB)
! .END
  
! .IF $(MKS_SUPPORT)
!   CFILES    +:= mksargv
!   AFILES    +:= argv 
!   MKS_DEF    := -DMKS_SUPPORT
! .ELSE
!   AFILES    +:= $(WHERE_ARGV)/setargv	# use Microsoft globber
! .END
  
! # Compiler version specific stuff: optimization levels, etc.
! # 6.0 auto defines _MSC_VER as 600, but 5.0 and 5.1 don't set _MSC_VER,
! # so we must.  Incredibly, 6.0 doesn't set __STDC__, so we must.
! # Override -FPa for 5.x.
  
! .IF $(FPOINT) == -FPa
!   ADJUSTED_FPOINT := -FPc
! .ELSE
!   ADJUSTED_FPOINT := $(FPOINT)
! .END
  
! CFLAGS     := -AL -nologo -G$(PROCESSOR) -Gt100
  
! PRE_600	   :=
! CFLAGS_600 := -D__STDC__ $(FPOINT)
! .IF $(DEBUGGING)
!   OPT_600  := -Od
! .ELSE
!   OPT_600  := -Oegcilsza
! .END
  
! PRE_510	   := -D_MSC_VER=
! CFLAGS_510 := 510 $(ADJUSTED_FPOINT)
! OPT_510    := -Ocils
  
! PRE_500	   := -D_MSC_VER=
! CFLAGS_500 := 500 $(ADJUSTED_FPOINT)
! OPT_500    := -Ocils
  
! INC_DIRS   := -I. -I..
  
! LDFLAGS := /stack:0x8000 /NOE /MAP
  
! ASFLAGS := -Dmlarge -t -mx
  
! .IF $(MIN_DOS_VER)
!   DOS_VER  := -DMIN_DOS_VER=$(MIN_DOS_VER:s,.,,)
! .END
! 
! .IF $(DEBUGGING)
!   CFLAGS  +:= -Zi
!   LDFLAGS +:= /CO	# not put in LDFLAGS since overlay version can't use it
!   ASFLAGS +:= -Zi
! .ELSE
!   CFLAGS  +:= -Gs	# no stack check
! .END
! 
! .IF $(GDBM)
!   CFLAGS  +:= -DHAS_NDBM
!   .IF $(GDBM_LNAME) == $(NULL)
!     GDBM_LNAME := lgdbm.lib
!   .END
!   LDLIBS +:= $(GDBM_LNAME)
! .END
! 
! CFLAGS     +:= $(INC_DIRS)
! 
! # Default target
! 
! default .PHONY : ../config_u.h perl$E perlglob$E
! 
! perl$E : {$(AFILES) $(CFILES)}$O
! 	$(LD) $(LDFLAGS) @$(mktmp,$(DIVFILE) $(&:t"+\n":s,/,\\,)\n\
! 	$(@:s,/,\\,)\n\
! 	,\n\
! 	$(LDLIBS:s,/,\\,)\n\
! 	NUL\n)
! 
! # This makes ../perly.c and ../perly.h from perl.y using MS-DOS bison.
! # If MS-DOS bison is not available, you can build these on Unix using
! # yacc or bison.  (The versions built for your Unix copies will work fine.)
! 
! ../perly.c ../perly.h .UPDATEALL : ../perly.y
! 	[
! 		$(RM) $(RMFLAGS) $(TMPDIR)/perly.y
! 		cp ../perly.y $(TMPDIR)
! 		echo Expecting 27 shift/reduce and 61 reduce/reduce conflicts...
! 		bison -d $(TMPDIR)/perly.y
! 		mv $(TMPDIR)/perly.h ../perly.h
! 		mv $(TMPDIR)/perly.c ..
! 		$(RM) $(RMFLAGS) $(TMPDIR)/perly.y
! 		cat >> ../perly.h <<END
! typedef union {
! 	int	ival;
! 	char *cval;
! 	ARG *arg;
! 	CMD *cmdval;
! 	struct compcmd compval;
! 	STAB *stabval;
! 	FCMD *formval;
! } YYSTYPE;
! 
! extern YYSTYPE yylval;
! END
! 	]
! 
! # Can't allow presence of Unix ../config.h: it will mess up perl.h's includes
! 
! ../config_u.h :
! .IF $(SHELL) == $(COMSPEC)
! 	[
! 	    cd ..
! 	    if exist config.h rename config.h config_u.h
! 	    if not exist config_u.h type NUL >config_u.h
! 	    cd $(MAKEDDIR)
! 	]
! .ELSE
! 	    mv ../config.h ../config_u.h || touch ../config_u.h
! .END
! 
! # perlglob.exe needed for non-MKS users only
! 
! perlglob$E: glob.c
! 	$(CC) -c $(FPOINT) -Fe$@ $<
! 	link /NOE glob + $(WHERE_ARGV:s,/,\,)\setargv$O, $* ;
! 
! tags: {$(CFILES)}.c {$(HFILES)}.h
! 	ctags -t $^
! 
! sys/dir.h : dir.h
! 	-$(MKDIR) sys
! 	$(CP) dir.h $(TARGET)
! 
! %$O : %.c
! 	$(CC) $(CFLAGS) $(MKS_DEF) $(PRE_$(MSC_VER))$(CFLAGS_$(MSC_VER)) $(OPT_$(MSC_VER)) -c $<
! 
! %$O : %$S
! 	$(AS) $(ASFLAGS) $(DOS_VER) $(<:s,/,\);
! 
! # Create dependencies file
! 
! depend .PHONY : {$(CFILES)}.c
! 	perl -S dp -o dlist.new -q $(INC_DIRS) -rn $&
! 	mv dlist.new dlist.mk
! 	
! 
! # Include automatically made dependencies
! 
! .INCLUDE : dlist.mk
