/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  (C) Copyright 1987-91, Bit Bucket Software Co., a Delaware Corporation. */
/*                                                                          */
/*                                                                          */
/*                Box Drawing subroutines for BinkleyTerm                   */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.250.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:491/0                          */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*                                                                          */
/*   This module is derived from code developed by Augie Hansen in his      */
/*   book "Proficient C" published by Microsoft Press.  Mr. Hansen was      */
/*   kind enough to give us verbal permission to use his routines, and      */
/*   Bob, Vince and Alan (and all our full screen users) are grateful.      */
/*   If you decide to use this code in some package you are doing, give     */
/*   some thought to going out and buying the book. He deserves that.       */
/*                                                                          */
/*--------------------------------------------------------------------------*/


/* Include this file before any other includes or defines! */

#include "includes.h"

#include "box.h"
#include "video.h"

static BOXTYPE box[] = {
   '+'  , '+'  , '+'  , '+'  , '-'  , '-'  , '|'  , '|'  ,
   ULC11, URC11, LLC11, LRC11, HBAR1, HBAR1, VBAR1, VBAR1,
   ULC22, URC22, LLC22, LRC22, HBAR2, HBAR2, VBAR2, VBAR2,
   ULC12, URC12, LLC12, LRC12, HBAR1, HBAR1, VBAR2, VBAR2,
   ULC21, URC21, LLC21, LRC21, HBAR2, HBAR2, VBAR1, VBAR1,
   BLOCK, BLOCK, BLOCK, BLOCK, HBART, HBARB, BLOCK, BLOCK
};

void sb_box (REGIONP win, int type, int attr)
{
   register int r;
   int x;
   int maxr, maxc;
   BOXTYPE *boxp;

   boxp = &box[type];
   maxc = win->c1 - win->c0;
   maxr = win->r1 - win->r0;
   x = maxc - 1;

   /* draw top row */
   sb_move (win, 0, 0);
   sb_wca (win, boxp->ul, attr, 1);
   sb_move (win, 0, 1);
   sb_wca (win, boxp->tbar, attr, x);
   sb_move (win, 0, maxc);
   sb_wca (win, boxp->ur, attr, 1);

   /* draw left and right sides */
   for (r = 1; r < maxr; r++)
      {
      sb_move (win, r, 0);
      sb_wca (win, boxp->lbar, attr, 1);
      sb_move (win, r, maxc);
      sb_wca (win, boxp->rbar, attr, 1);
      }

   /* draw bottom row */
   sb_move (win, maxr, 0);
   sb_wca (win, boxp->ll, attr, 1);
   sb_move (win, maxr, 1);
   sb_wca (win, boxp->bbar, attr, x);
   sb_move (win, maxr, maxc);
   sb_wca (win, boxp->lr, attr, 1);
}

