Code from "Converting a Turbo C Program to a TSR" by Michael J.
Young, PJ, Volume 6.2.  Copyright 1987 Michael J. Young.

Listing 2

/* Error codes returned by 'TsrInstall' if it cannot install the TSR.       */

#define ERROR       1        /* General, undefined error.                   */
#define WRONGDOS    2        /* Version of DOS prior to 2.0.                */
#define INSTALLED   3        /* TSR has already been installed in memory.   */
#define NOINT       4        /* No free user interrupts are available.      */

/* Constant definitions for hotkey shift mask.                              */

#define RIGHTSHIFT       0x0001
#define LEFTSHIFT        0x0002
#define CONTROL          0x0004
#define ALT              0x0008
#define SCROLLSTATE      0x0010
#define NUMLOCKSTATE     0x0020
#define CAPLOCKSTATE     0x0040
#define INSERTSTATE      0x0080
#define CTRLNUMLKSTATE   0x0800
#define SCROLLLOCK       0x1000
#define NUMLOCK          0x2000
#define CAPSLOCK         0x4000
#define INSERT           0x8000

/* Variables and functions.                                                 */

typedef void interrupt (*VIFP) ();      /* Void Interrupt Function Pointer. */
int TsrInstall (void (*FPtr) (void),int HotKey, VIFP Code);
int TsrInDos (void);
